agents

## Class HealthInsuranceCompany

- java.lang.Object
- - agents.Agent
  - - agents.HealthInsuranceCompany

-     public class HealthInsuranceCompany
      extends Agent

  Version:
    1.0
  Author:
    Alan Mills

    This class implements the Health Insurance Company. The health insurance company pays claims to PCPs and Specialists, assesses the performance quality of PCPs and Specialists, and determines which PCPs and Specialists will remain in the network. There is one Insurance company. All people in the community have health insurance through the Insurance Company.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `HealthInsuranceCompany(AgentID pHealthInsuranceCompanyID)` Constructs a HealthInsuranceCompany agent.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getHealthInsuranceCompanyGoal1()` Returns the HealthInsuranceCompany's first goal as a string.
    `java.lang.String` | `getHealthInsuranceCompanyGoal2()` Returns the HealthInsuranceCompany's second goal as a string.
    `java.lang.String` | `getHealthInsuranceCompanyGoal3()` Returns the HealthInsuranceCompany's third goal as a string.
    `void` | `i1_GetClaimSubmissions()`
    `void` | `init_InitializeVariables_BOY()` Initializes variables (used at the beginning of each simulation period).
    `void` | `init_InitializeVariables_Constructor()` Initializes variables (used in the constructor).
    `void` | `p1_UpdateNetworkStatus()`
    `java.lang.String` | `probe_GetHealthInsuranceCompanyIDString()` Returns the Health Insurance Company's identification number as a string.
    `Goal` | `r1_DetermineFirstGoal()`
    `java.util.ArrayList<AgentID>` | `r2_DetermineIneffectivePhysicians(int numberOfPreviousPeriods)`
    `java.util.ArrayList<AgentID>` | `r3_DetermineUnderUtilizedPhysicians()`

    - ### Methods inherited from class agents.Agent

      `getAgentFirstPriorityGoalDescription, getAgentID, getAgentSecondPriorityGoalDescription, getAgentXLocation, getAgentYLocation, setAgentFirstPriorityGoalDescription, setAgentID, setAgentSecondPriorityGoalDescription, setAgentXLocation, setAgentYLocation`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### HealthInsuranceCompany

          public HealthInsuranceCompany(AgentID pHealthInsuranceCompanyID)

      Constructs a HealthInsuranceCompany agent. The constructor sets the Health Insurance Company's attributes based on input parameters.
      Parameters:
        `pSpace` - The identifier for the "space" simulation environment.
        `pHealthInsuranceCompanyID` - The HealthInsuranceCompany's identifier.

  - ### Method Detail

    - #### init_InitializeVariables_Constructor

          public void init_InitializeVariables_Constructor()

      Initializes variables (used in the constructor).

    - #### init_InitializeVariables_BOY

          public void init_InitializeVariables_BOY()

      Initializes variables (used at the beginning of each simulation period).

    - #### i1_GetClaimSubmissions

          public void i1_GetClaimSubmissions()

    - #### p1_UpdateNetworkStatus

          public void p1_UpdateNetworkStatus()

    - #### r1_DetermineFirstGoal

          public Goal r1_DetermineFirstGoal()

    - #### r2_DetermineIneffectivePhysicians

          public java.util.ArrayList<AgentID> r2_DetermineIneffectivePhysicians(int numberOfPreviousPeriods)

    - #### r3_DetermineUnderUtilizedPhysicians

          public java.util.ArrayList<AgentID> r3_DetermineUnderUtilizedPhysicians()

    - #### probe_GetHealthInsuranceCompanyIDString

          public java.lang.String probe_GetHealthInsuranceCompanyIDString()

      Returns the Health Insurance Company's identification number as a string.
      Returns:
        the Health Insurance Company's identification number as a string.

    - #### getHealthInsuranceCompanyGoal1

          public java.lang.String getHealthInsuranceCompanyGoal1()

      Returns the HealthInsuranceCompany's first goal as a string.
      Returns:
        A string with the HealthInsuranceCompany's first goal.

    - #### getHealthInsuranceCompanyGoal2

          public java.lang.String getHealthInsuranceCompanyGoal2()

      Returns the HealthInsuranceCompany's second goal as a string.
      Returns:
        A string with the HealthInsuranceCompany's second goal

    - #### getHealthInsuranceCompanyGoal3

          public java.lang.String getHealthInsuranceCompanyGoal3()

      Returns the HealthInsuranceCompany's third goal as a string.
      Returns:
        A string with the HealthInsuranceCompany's third goal